package cn.com.tenlion.materialstore.service.materialphoto;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.materialstore.pojo.dtos.materialphoto.MaterialPhotoDTO;
import cn.com.tenlion.materialstore.pojo.vos.materialphoto.MaterialPhotoVO;
import cn.com.tenlion.materialstore.pojo.bos.materialphoto.MaterialPhotoBO;
import cn.com.tenlion.materialstore.pojo.pos.materialphoto.MaterialPhotoPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMaterialPhotoService
 * @Description: 图片素材
 * @Author: CodeFactory
 * @Date: 2021-05-28 11:04:34
 * @Version: 3.0
 **/
public interface IMaterialPhotoService {

    /**
     * 新增图片素材
     *
     * @param materialPhotoVO
     * @return
     */
    void save(MaterialPhotoVO materialPhotoVO);

    /**
     * 新增图片素材
     *
     * @param token
     * @param materialPhotoVO
     * @return
     */
    void save(String token, MaterialPhotoVO materialPhotoVO);

    /**
     * 新增图片素材
     *
     * @param materialPhotoVO
     * @return materialPhotoId
     */
    String saveReturnId(MaterialPhotoVO materialPhotoVO);

    /**
     * 新增图片素材
     *
     * @param token
     * @param materialPhotoVO
     * @return materialPhotoId
     */
    String saveReturnId(String token, MaterialPhotoVO materialPhotoVO);

    /**
     * 删除图片素材
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除图片素材
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除图片素材（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改图片素材
     *
     * @param materialPhotoId
     * @param materialPhotoVO
     * @return
     */
    void update(String materialPhotoId, MaterialPhotoVO materialPhotoVO);

    /**
     * 修改图片素材
     *
     * @param token
     * @param materialPhotoId
     * @param materialPhotoVO
     * @return
     */
    void update(String token, String materialPhotoId, MaterialPhotoVO materialPhotoVO);

    /**
     * 图片素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialPhotoDTO get(Map<String, Object> params);

    /**
     * 图片素材详情
     *
     * @param materialPhotoId
     * @return
     */
    MaterialPhotoDTO get(String materialPhotoId);

    /**
     * 图片素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialPhotoBO getBO(Map<String, Object> params);

    /**
     * 图片素材详情
     *
     * @param materialPhotoId
     * @return
     */
    MaterialPhotoBO getBO(String materialPhotoId);

    /**
     * 图片素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialPhotoPO getPO(Map<String, Object> params);

    /**
     * 图片素材详情
     *
     * @param materialPhotoId
     * @return
     */
    MaterialPhotoPO getPO(String materialPhotoId);

    /**
     * 图片素材列表
     *
     * @param params
     * @return
     */
    List<MaterialPhotoDTO> list(Map<String, Object> params);

    /**
     * 图片素材列表
     *
     * @param params
     * @return
     */
    List<MaterialPhotoBO> listBO(Map<String, Object> params);

    /**
     * 图片素材列表
     *
     * @param params
     * @return
     */
    List<MaterialPhotoPO> listPO(Map<String, Object> params);

    /**
     * 图片素材分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MaterialPhotoDTO>> listPage(ListPage page);

    /**
     * 图片素材统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    List<MaterialPhotoDTO> getByMaterialId(String materialId);

    void removeByMaterialId(String materialId);

    void updateCheck(String id);
}